#include <tclap/CmdLine.h>
#include <UDP_Protocol_Configurator.h>

using namespace inaf::oasbo::ConnectionProtocols;
UDPProtocolConfigurator::UDPProtocolConfigurator(){
	setIp("127.0.0.1");
	setPort(9003);
}


UDPProtocolConfigurator::UDPProtocolConfigurator(int argc, char ** argv){
	try {
		TCLAP::CmdLine cmd("Usage Description WIP", ' ', "1");
		cmd.ignoreUnmatched(true);
		TCLAP::ValueArg<std::string> ip("","ip","Host IP address",false,"127.0.0.1","X.X.X.X");
		cmd.add( ip );
		TCLAP::ValueArg<std::string> port("","port","listening port of the host",false,"9003","int");
		cmd.add( port );


		cmd.parse( argc, argv );

		setIp(ip.getValue());
		setPort(std::stoi(port.getValue()));

	}catch (TCLAP::ArgException &e){  // catch any exceptions
		std::cerr << "error: " << e.error() << " for arg " << e.argId() << std::endl;
		exit(EXIT_FAILURE);
	}
}

BaseProtocol * UDPProtocolConfigurator::createProtocol(){
		return new UDPProtocol(getIp(),getPort());
}

UDPProtocol * UDPProtocolConfigurator::createUDPProtocol(){
		return new UDPProtocol(getIp(),getPort());
}


